﻿-- Original Author and Manager : Zaultar
-- Update Author : Jaxom of Hellfire
-- Create Date : 11/27/2008 10:17:49 PM
-- Update Date : 24/12/2014 by Jaxom of Hellfire
-- _O1_ OnLoad()
-- _02_ OnEvent()

-- Addon constants
WTF_NAME 	= "Who TF RU"
WTF_VNMBR	= 600000		-- Number code for this version

-- Colors
WTF_HELP_COLOR		= "|cFFFFFF7F"
WTF_ERROR_COLOR	    = "|cFFFF0000"
WTF_UNKNOWN_COLOR	= "|cFF7F7F7F"
WTF_TOKEN_COLOR	    = "|cFFFF0000"
WTF_NORMAL_COLOR     = "|r"

WTF_NOTE_COLOR       = "|cFFFFFF7F"   -- Who TF RU
WTF_FRIEND_COLOR     = "|cFFE5B200"   -- Neutral
WTF_GUILD_COLOR      = "|cFF00FF00"   -- or lighter green "|cFFC0FFC0"

-- Stored Data
if not WTF_State then WTF_State = {} end		-- Data saved between sessions
if not WTF_Notes then WTF_Notes = {} end		-- Names database
if not WTF_FNotes then WTF_FNotes = {} end	-- Friend Notes database
if not WTF_GNotes then WTF_GNotes = {} end	-- Guild Notes database
if not WTF_FData then WTF_FData = {} end		-- Friend Data (level, class zone)
if not WTF_GData then WTF_GData = {} end		-- Friend Data (level, class zone)

-- Slash variables
local SLASH_ON = "on";			-- Enabled Who TF RU? (really?)
local SLASH_OFF = "off";		-- Enabled Who TF RU? (really?)
local SLASH_ADD = "add"			-- Add a player note
local SLASH_WHO = "whois"		-- Whois a user
local SLASH_COLOR = "color"		-- Toggles Color on/off
local SLASH_DEBUG = "debug";	-- Toggles Debug output on/off
local SLASH_STATUS = "status";  -- Displays current settings
local SLASH_FRIENDS = "friends";-- Dump friends notes into array
local SLASH_GUILD = "guild";    -- Dump friends notes into array

local WTF_Global_Name = "";
local WTF_Global_Note = "";


-- _01_ OnLoad() Handler	
------------------------------------------------------------
function WTF_OnLoad(self) 
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("FRIENDLIST_UPDATE");
	self:RegisterEvent("GUILD_ROSTER_UPDATE");
	self:RegisterEvent("VARIABLES_LOADED");
	
	SLASH_CHATNOTES1 = "/whotfru"
	SLASH_CHATNOTES2 = "/wtf"
	SlashCmdList["CHATNOTES"] = WTF_ParseSlash;
	
	SLASH_WHOIS1 = "/whois"
	SlashCmdList["WHOIS"] = WTF_WhoPlayer;

	SLASH_ADD1 = "/add"
	SlashCmdList["ADD"] = WTF_AddCommand;
	
	DEFAULT_CHAT_FRAME:AddMessage(WTF_HELP_COLOR..WTF_NAME..":|r "..WTF_TXT.loaded..WTF_HELP_COLOR..WTF_TXT.loadedtext);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", WTF_ChatFilter)
	
	-- use ChatFilter_System (a copy of ChatFilter) so we can see if we see strings without account names.
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", WTF_ChatFilter_System)

	-- Chat Frame Menu to add/remove
	UnitPopupMenus["CHATNOTES"] = {"CHATNOTES_ADD", "CHATNOTES_REMOVE", "CANCEL"};
	UnitPopupButtons["CHATNOTES"] = { text = WTF_MENU_MAIN, dist = 0, nested = 1};
	UnitPopupButtons["CHATNOTES_ADD"] = { text = WTF_MENU_ADD, dist = 0,};
	UnitPopupButtons["CHATNOTES_REMOVE"] = { text = WTF_MENU_REMOVE, dist = 0 };

	table.insert(UnitPopupMenus["PLAYER"], #UnitPopupMenus["PLAYER"]-1, "CHATNOTES");
	table.insert(UnitPopupMenus["FRIEND"], #UnitPopupMenus["FRIEND"]-1, "CHATNOTES");
	table.insert(UnitPopupMenus["PARTY"], #UnitPopupMenus["PARTY"]-1, "CHATNOTES");

	hooksecurefunc("UnitPopup_OnClick", WTF_UnitPopupOnClick);
	
	-- Static PopUp Dialogs
    
	StaticPopups();
end

function StaticPopups(self)
	-- You have you are removing a player's Who TF RU
   	StaticPopupDialogs["CHATNOTE_POPUP_REMOVE"] = {
		text = "Are you sure you want to REMOVE the Who TF RU for (%s)",
		button1 = TEXT(YES),
		button2 = TEXT(NO),
		OnAccept = function(data)
			data = WTF_Global_Name
		    if (data) then 
				if (WTF_Notes[data]) then
					WTF_Notes[data] = nil
					WTF_Debug("("..data..") Who TF RU REMOVED")
				else
					WTF_Debug("("..data..") Doesn't exist in WTF_Notes")
				end
			end
		end,
		OnHide = function(data)
		end,
		whileDead = 1;
		timeout = 30;
		hideOnEscape = 1
	};
	-- Add or Modify a players existing Who TF RU
   	StaticPopupDialogs["CHATNOTE_POPUP_ADDMODIFY"] = {
		text = "Set Who TF RU for player (%s)",
		button1 = TEXT(YES),
		button2 = TEXT(NO),
		OnShow = function(self)
			if (WTF_Global_Note) then self.editBox:SetText(WTF_Global_Note) end
		end,
        	OnAccept = function(self, data)
			local player = WTF_Global_Name
			local note = nil
			note = self.editBox:GetText()
			-- Set a blank to a nil to erase value
			if (note == "") then note = nil end
			if (note) then
				WTF_Notes[player] = note
			    WTF_Debug("Added Note for ["..player.."] ("..note..")");
			end
--			if (self.editBox:GetText()) then WTF_Debug("Data Name:"..self.editBox:GetText()) end
		end,
		OnHide = function(data)
		    WTF_Debug("OnHide:");
		end,
        	EditBoxOnEnterPressed = function(self)
			local player = WTF_Global_Name
			local note = nil
			note = self:GetText()
			-- Set a blank to a nil to erase value
			if (note == "") then note = nil end
			if (note) then
				WTF_Notes[player] = note
--		    WTF_Debug("Added Note for ["..player.."] ("..note..")");
			end
			WTF_Debug("Enter Pressed")
			self:GetParent():Hide();
        	end,
    		EditBoxOnEscapePressed = function (self)
        		self:GetParent():Hide();
    		end,		
		whileDead = 1,
		timeout = 0,
		exclusive = 1,
		hideOnEscape = 1,
		hasEditBox = 1
	};
end

-- PopUp Menu on chat frame
function WTF_UnitPopupOnClick(self)
	local dropdownFrame = UIDROPDOWNMENU_INIT_MENU;
	local button = self.value;
	local name = dropdownFrame.name;
	
	if button == "CHATNOTES_ADD" then
	    WTF_Debug ("CHATNOTES_ADD Name:"..name);
	    WTF_Global_Name = name
	    if (WTF_Notes[name]) then
			WTF_Global_Note = WTF_Notes[name]
		else
			WTF_Global_Note = ""
		end
	    local dialog = StaticPopup_Show("CHATNOTE_POPUP_ADDMODIFY", name);
		if dialog then dialog.data = name end
	    WTF_Debug ("CHATNOTES_ADD  Name:"..name);
	    ToggleDropDownMenu(1, nil, dropdownFrame, "cursor");
	elseif button == "CHATNOTES_REMOVE" then
--	    WTF_Debug ("CHATNOTES_REMOVE  Name:"..name);
		-- Set the name to pass in, since we can't seem to figure out the parameters
	    WTF_Global_Name = name
	    local dialog = StaticPopup_Show("CHATNOTE_POPUP_REMOVE", name);
		if dialog then dialog.data = name end
--	    WTF_Debug ("CHATNOTES_REMOVE  Name:"..name);
	    ToggleDropDownMenu(1, nil, dropdownFrame, "cursor");
	elseif button == "CANCEL" then
	    ToggleDropDownMenu(1, nil, dropdownFrame, "cursor");
	end

	return;
end


-- Filter Chat input and add our note to the begining of the string.
function WTF_ChatFilter(self,event,msg,author, ...)
	local output = nil
	local note = ""
	if (WTF_Notes[author] ) then
		if (WTF_State.color) then output = WTF_NOTE_COLOR else output = "" end
		note = WTF_Notes[author];
	elseif (WTF_FNotes[author] ) then
		if (WTF_State.color) then output = WTF_FRIEND_COLOR else output = "" end
		note = WTF_FNotes[author];
	elseif (WTF_GNotes[author] ) then
		if (WTF_State.enabled) then
			if (WTF_State.color) then output = WTF_GUILD_COLOR else output = "" end
			note = WTF_GNotes[author];
		end
	end

	-- If we have set anything in output, then we know to output our text
	if (output) then
--		return false, output.."("..note..") "..WTF_NORMAL_COLOR..msg
   	   msg = output.."("..note..") "..WTF_NORMAL_COLOR..tostring(msg)
	   return false, msg,author, ...
	end
end


-- Filter Chat input and add our note to the begining of the string.
function WTF_ChatFilter_System(self,event,msg,...)
	local output = nil
	local note = ""
	local playername = "";
	local playernotes = nil;
	local playerdata = nil;

	-- For system messages fire and set msg to full string, with name inside
	if (string.find(msg, WTF_TXT.sys_goneoffline)) then
	   playername = string.sub(msg, 1, string.find(msg, " ")-1)
	   --WTF_Debug("<"..playername..">");
	   
	   if (WTF_GNotes[playername]) then playernotes = WTF_GNotes[playername]; end
	   if (WTF_FNotes[playername]) then playernotes = WTF_FNotes[playername]; end
	   if (WTF_Notes[playername]) then playernotes = WTF_Notes[playername]; end
	   
	   if (WTF_GData[playername]) then playerdata = WTF_GData[playername]; end
	   if (WTF_FData[playername]) then playerdata = WTF_FData[playername]; end
	   
	   if (playernotes) then
		  output = playername.." ("..playernotes..")";
		  if (playerdata) then
			 output = output.." "..playerdata;
		  end
		  output = output.." "..WTF_TXT.sys_goneoffline;
	   end
   	end

	if (string.find(msg, WTF_TXT.sys_comeonline)) then
		WTF_Debug(">"..msg.."<");
		-- sometimes online has a [<playername>] and sometimes it doesn't (guild).
		if (string.find(msg,"|")) then
			playername = string.sub (msg, string.find(msg, ":", 1, true)+1 )
			playername = string.sub (playername, 1 , string.find(playername, "|", 1, true)-1 )
		else
			playername = string.sub(msg, 2, string.find(msg, "]")-1)
		end
		WTF_Debug("<"..playername..">");

		   
	   if (WTF_GNotes[playername]) then playernotes = WTF_GNotes[playername]; end
	   if (WTF_FNotes[playername]) then playernotes = WTF_FNotes[playername]; end
	   if (WTF_Notes[playername]) then playernotes = WTF_Notes[playername]; end
	   
	   if (WTF_GData[playername]) then playerdata = WTF_GData[playername]; end
	   if (WTF_FData[playername]) then playerdata = WTF_FData[playername]; end
	   
	   if (playernotes) then
		  output = playername.." ("..playernotes..")";
		  if (playerdata) then
			 output = output.." "..playerdata;
		  end
		  output = output.." "..WTF_TXT.sys_comeonline;
	   end
   	end

	-- <name> joins the party. (sys_joinsparty)
	if (string.find(msg, "joins the party")) then
		WTF_Debug(">"..msg.."<");
	end
	-- If we have set anything in output, then we know to output our text
	if (output) then
		return false, output, ...
	end
end


-- _02_ OnEvent() Handler
------------------------------------------------------------
function WTF_OnEvent(self, event, arg1, ...) 
	if (event == "ADDON_LOADED") then
		if (arg1 == "WTF") then
			-- TODO output to screen when setting defaults!
			-- Set State Variables
			if WTF_State.debug == nil then WTF_State.debug = false end
			if WTF_State.color == nil then WTF_State.color = false end
			if WTF_State.enabled == nil then WTF_State.enabled = true end
			-- Display Status
			WTF_DisplayStatus()
			WTF_PanelOptions()
			WTF_PanelUpdate()
		end
	elseif (event == "VARIABLES_LOADED") then
		WTF_Debug(event.."(START)")
		WTF_Debug(event.." (END)")
	elseif (event == "GUILD_ROSTER_UPDATE") then
		WTF_GuildList();
	elseif (event == "FRIENDLIST_UPDATE") then
		WTF_FriendsList(false);
	end
end


function WTF_PanelOptions()
	WTF_OptionsHeader = WTF_Panel:CreateFontString(nil, "ARTWORK")
	WTF_OptionsHeader:SetFontObject(GameFontNormalLarge)
	WTF_OptionsHeader:SetPoint("TOPLEFT", 16, -16)
	WTF_OptionsHeader:SetText("Who TF RU v1.5.2")
	
	WTF_GeneralHeader = WTF_Panel:CreateFontString(nil, "ARTWORK")
	WTF_GeneralHeader:SetFontObject(GameFontWhite)
	WTF_GeneralHeader:SetPoint("TOPLEFT", WTF_OptionsHeader, "BOTTOMLEFT", 0, -6)
	WTF_GeneralHeader:SetText("General Options:")
    
    WTF_GeneralHeader1 = WTF_Panel:CreateFontString(nil, "ARTWORK")
	WTF_GeneralHeader1:SetFontObject(GameFontWhite)
	WTF_GeneralHeader1:SetPoint("TOPLEFT", WTF_OptionsHeader, "BOTTOMLEFT", 0, -20)
	WTF_GeneralHeader1:SetText("Authors: Zaultar of ??? and Jaxom of Hellfire")

	WTF_PanelGuildNotes = CreateFrame("CheckButton", "WTF_PanelGuildNotes", WTF_Panel, "OptionsCheckButtonTemplate")
	WTF_PanelGuildNotes:SetPoint("TOPLEFT", "WTF_GeneralHeader", "BOTTOMLEFT", 0, -15)
	WTF_PanelGuildNotesText:SetText("Automatically display Guild Notes")

	WTF_PanelColor = CreateFrame("CheckButton", "WTF_PanelColor", WTF_Panel, "OptionsCheckButtonTemplate")
	WTF_PanelColor:SetPoint("TOPLEFT", "WTF_PanelGuildNotes", "BOTTOMLEFT", 0, -4)
	WTF_PanelColorText:SetText("Colorize notes based on where they are set")

    
        
end

function WTF_PanelUpdate()
	WTF_PanelGuildNotes:SetChecked(WTF_State.enabled)
	WTF_PanelColor:SetChecked(WTF_State.color)
end

function WTF_PanelOkay()
	WTF_State.enabled = WTF_PanelGuildNotes:GetChecked()
	WTF_State.color = WTF_PanelColor:GetChecked()
end

function WTF_PanelSettingsDefault()
	-- WTF_PanelGuildNotes:SetChecked(WTF_State.enabled)

end


function WTF_Panel_OnLoad(WTF_Panel)
---------
	WTF_Panel.name = "Who TF RU"
	WTF_Panel.okay = function (self) WTF_PanelOkay(); end;
	WTF_Panel.default = function (self) WTF_PanelSettingsDefault(); WTF_PanelUpdate(); end;
	InterfaceOptions_AddCategory(WTF_Panel)

end --function


-- _03_ - OnEvent Functions
------------------------------------------------------------

-- Main routine for adding a Note to a specific player name
------------------------------------------------------------
function WTF_AddPlayerNote (player, note)
	local previousnote = WTF_Notes[player];
	if (previousnote) then
		WTF_Notes[player] = note;
		DEFAULT_CHAT_FRAME:AddMessage(WTF_HELP_COLOR..WTF_TXT.updated..WTF_NORMAL_COLOR..string.format(" %s:%s (it was: %s)",player,note,previousnote));
	else
		WTF_Notes[player] = note;
		DEFAULT_CHAT_FRAME:AddMessage(string.format(WTF_HELP_COLOR..WTF_TXT.added..WTF_NORMAL_COLOR.." %s:%s",player,note));
	end
end

-- _04_ Chat Window Functions

------------------------
-- _05_ Slash Handler --
------------------------

-- Main Slash Command handler
------------------------------------------------------------
function WTF_ParseSlash(msg) 
	local cmd, params = WTF_Extract_NextParameter(msg);
	if (cmd == SLASH_ON) then	
		WTF_State.enabled = true;
		WTF_PanelUpdate();
		WTF_DisplayStatus();
	elseif (cmd == SLASH_OFF) then
		WTF_State.enabled = false;
		WTF_PanelUpdate();
		WTF_DisplayStatus();
	elseif (cmd == SLASH_STATUS) then
		WTF_DisplayStatus();
	elseif (cmd == SLASH_ADD) then
		if (params) then
			local playername, note = WTF_Extract_NextParameter(params);
			WTF_AddPlayerNote(WTF_MixedCase(playername), note);
		else
			WTF_DisplayAddUsage();
		end
	elseif (cmd == SLASH_WHO) then
		if (params) then
			WTF_WhoPlayer(params);
		else
			WTF_DisplayWhoUsage();
		end
	elseif (cmd == SLASH_COLOR) then
	    WTF_State.color = not WTF_State.color
	    WTF_PanelUpdate();
	    WTF_DisplayStatus();
	elseif (cmd == SLASH_FRIENDS) then
		WTF_FriendsList(true);
	elseif (cmd == SLASH_GUILD) then
		WTF_GuildList(true);
	elseif (cmd == SLASH_DEBUG) then
		WTF_State.debug = not WTF_State.debug;
		WTF_DisplayStatus();
	else 
		--WTF_DisplayUsage();
		InterfaceOptionsFrame_OpenToCategory(WTF_Panel)
	end
	
end

-- Generic Add command, parses input to ensure we have a name value pair
------------------------------------------------------------
function WTF_AddCommand (cmd)
	if (cmd) then
		local playername, note = WTF_Extract_NextParameter(cmd);

		-- Normalize the inputed player name
		playername = WTF_MixedCase(playername)
		
		if (note) then
			WTF_AddPlayerNote (playername, note);
		else
			WTF_DisplayAddUsage();
		end
	else
		WTF_DisplayUsage();
	end
end

-- /whois handler for quick query of a username
------------------------------------------------------------
function WTF_WhoPlayer (player)
	local playernote = nil
	local playerdata = ""

	-- Normalize the inputed player name
	player = WTF_MixedCase(player)

	-- Get Player Data from either Friend or Guild
	if (WTF_GData[player]) then
		playerdata = WTF_GData[player]
	end
	if (WTF_FData[player]) then
		playerdata = WTF_FData[player]
	end

	if (WTF_Notes[player]) then
		WTF_Print(WTF_HELP_COLOR.."Whois: ["..player.."]: ("..WTF_Notes[player]..")")
	elseif (WTF_FNotes[player]) then
		WTF_Print(WTF_HELP_COLOR.."Whois: ["..player.."]: ("..WTF_FNotes[player]..")"..playerdata)
	elseif (WTF_GNotes[player]) then
		WTF_Print(WTF_HELP_COLOR.."Whois: ["..player.."]: ("..WTF_GNotes[player]..")"..playerdata)
	end		
end

function WTF_FriendsList(output)
	local numFriends = GetNumFriends();
--	WTF_Debug ("Friends: "..numFriends);
	local numFriendsOnline = 0;
	local name, level, class, zone, connected, status, note
	local friendIndex
	if (numFriends > 0) then
		for friendIndex=1, numFriends do
			name, level, class, zone, connected, status, note = GetFriendInfo(friendIndex);
			if (name) then
				-- If we have class info, then we know we got something.
				if (level > 0) then
					if (not zone) then zone="" end
					WTF_FData[name]=class.." ("..level..") in "..zone
				end 
				if (note) then
					note = strtrim(note);
					if (note) then
						if (output) then
							WTF_Print("["..name.."] ("..note..")");
						end
						WTF_FNotes[name]=note;
					else
						if (output) then
							WTF_Print("["..name.."]");
						end
						WTF_FNotes[name]=nil;
					end
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("Error: Problem retrieving friend information")
			end
			num=friendIndex;
		end
		if (output) then
			WTF_Print("Retrieved data for "..num.." friends")
		end
	else
		WTF_Debug("[WTF] Friend info unavailable. Please open the friend window once per session.")
	end
end

-- Populate the WTF_GNotes database?
----------------------------------
function WTF_GuildList(output)
	local numGuild = GetNumGuildMembers();
	local numGuildOnline = 0;
	local name, level, class, zone, connected, status, note
	local guildIndex
	if (numGuild > 0) then
--		WTF_Debug ("Guild: "..numGuild);
		for guildIndex=1, numGuild do
			name, rank, rankIndex, level, class, zone, note, officernote, connected = GetGuildRosterInfo(guildIndex);
			if (name) then
				-- If we have class info, then we know we got something.
				if (level > 0) then
					if (not zone) then zone="" end
					WTF_GData[name]=class.." ("..level..") in "..zone
				end 
				-- Check it exists, and if so, trim any white space
				if (note) then
					note = strtrim(note);
					if (note) then
						if (output) then
							WTF_Print("["..name.."] ("..note..")");
						end
						if (strlen(note) > 0) then
						   WTF_GNotes[name]=note;
						else
							WTF_GNotes[name]=nil;
						end
					else
						if (output) then
							WTF_Print("["..name.."]");
						end
						WTF_GNotes[name]=nil;
					end
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("Error: Problem retrieving guild information")
			end
			num=guildIndex;
		end
		if (output) then
			WTF_Print("Retrieved data for "..num.." guild members")
		end
	else
		WTF_Debug("[WTF] Guild info unavailable. Please open the guild window once per session.")
	end
end

function WTF_DumpColor()
FIZ_HELP_COLOUR		= "|cFFFFFF7F"
FIZ_ERROR_COLOUR	= "|cFFFF0000"
FIZ_UNKNOWN_COLOUR	= "|cFF7F7F7F"
FIZ_HOSTILE_COLOUR	= "|cFFCC4C38"
FIZ_NEUTRAL_COLOUR	= "|cFFE5B200"
FIZ_FRIENDLY_COLOUR	= "|cFF009919"
FIZ_NEW_REP_COLOUR	= "|cFF7F7FFF"
FIZ_NEW_STANDING_COLOUR	= "|cFF6060C0"
FIZ_BAG_COLOUR		= "|cFFC0FFC0"
FIZ_BAG_BANK_COLOUR	= "|cFFFFFF7F"
FIZ_QUEST_COLOUR	= "|cFFC0FFC0"
FIZ_HIGHLIGHT_COLOUR    = "|cFF00FF00"
FIZ_QUEST_ACTIVE_COLOUR	= "|cFFFF7F7F"
FIZ_LOWLIGHT_COLOUR	= "|cFFFF3F3F"
FIZ_SUPPRESS_COLOUR	= "|cFF7F7F7F"

    WTF_Debug(FIZ_HELP_COLOUR.."FIZ_HELP_COLOUR"..FIZ_ERROR_COLOUR.."FIZ_ERROR_COLOUR"..FIZ_UNKNOWN_COLOUR.."FIZ_UNKNOWN_COLOUR"..FIZ_HOSTILE_COLOUR.."FIZ_HOSTILE_COLOUR"..FIZ_NEUTRAL_COLOUR.."FIZ_NEUTRAL_COLOUR"..FIZ_FRIENDLY_COLOUR.."FIZ_FRIENDLY_COLOUR"..FIZ_NEW_REP_COLOUR.."FIZ_NEW_REP_COLOUR"..FIZ_NEW_STANDING_COLOUR.."FIZ_NEW_STANDING_COLOUR"..FIZ_BAG_COLOUR.."FIZ_BAG_COLOUR"..FIZ_BAG_BANK_COLOUR.."FIZ_BAG_BANK_COLOUR"..FIZ_QUEST_COLOUR.."FIZ_QUEST_COLOUR"..FIZ_HIGHLIGHT_COLOUR.."FIZ_HIGHLIGHT_COLOUR"..FIZ_QUEST_ACTIVE_COLOUR.."FIZ_QUEST_ACTIVE_COLOUR"..FIZ_LOWLIGHT_COLOUR.."FIZ_LOWLIGHT_COLOUR"..FIZ_SUPPRESS_COLOUR.."FIZ_SUPPRESS_COLOUR");
end

-- Handles processing commandline items in single chunks
------------------------------------------------------------
function WTF_Extract_NextParameter(msg)
	local params = msg;
	local command = params;
	local index = strfind(command, " ");
	if ( index ) then
		command = strsub(command, 1, index-1);
		params = strsub(params, index+1);
	else
		params = nil;
	end
	return command, params;
end


-----------------------------------
-- _06_ General Helper Functions --
-----------------------------------

------------------------------------------------------------
function WTF_Print(msg, forceDefault)
	if not (msg) then return end
		DEFAULT_CHAT_FRAME:AddMessage(msg)
end

function WTF_Debug(msg)
	if not (msg) then return end
	if (WTF_State.debug) then
		DEFAULT_CHAT_FRAME:AddMessage(msg)
	end
end

function WTF_SafeConcat2(str1, str2)
	if str1 and str2 then 
		return str1..str2
	elseif str1 then
		return str1
	elseif str2 then
		return str2
	else
		return nil
	end
end

-- Returns the string in proper Mixed Case... First letter capitalized, the rest lower
function WTF_MixedCase(str)
	--return string.upper(string.sub(str,1,1))..string.sub(string.lower(str),2,-1))
	local Mixed = string.upper(str:sub(1,1))..string.sub(str:lower(),2,-1)
	--return string.upper(string.sub(str,1,1))..string.sub(string.lower(str),2,-1))
	return Mixed
end

-----------------------------------
-- _07_ Information
-----------------------------------

------------------------------------------------------------
function WTF_About()
	local ver = GetAddOnMetadata("WTF", "Version");
	local date = GetAddOnMetadata("WTF", "X-Date");
	local author = GetAddOnMetadata("WTF", "Author");
	local web = GetAddOnMetadata("WTF", "X-Website");

	if (author ~= nil) then
		WTF_Print(WTF_NAME.." "..WTF_TXT.by.." "..WTF_HELP_COLOR..author.."|r", true);
	end
	if (ver ~= nil) then
		WTF_Print("  "..WTF_TXT.version..": "..WTF_HELP_COLOR..ver.."|r", true);
	end
	if (date ~= nil) then
		WTF_Print("  "..WTF_TXT.date..": "..WTF_HELP_COLOR..date.."|r", true);
	end
	if (web ~= nil) then
		WTF_Print("  "..WTF_TXT.web..": "..WTF_HELP_COLOR..web.."|r", true);
	end
end


function WTF_DisplayUsage()
	-- WTF_Print(" ", true);
	WTF_Print(WTF_HELP_COLOR..WTF_NAME..":|r "..WTF_TXT.help, true);
	WTF_Print(WTF_HELP_COLOR..WTF_TXT.usage..":|r "..WTF_TOKEN_COLOR..SLASH_ON.."/"..SLASH_OFF..WTF_HELP_COLOR.." -- "..WTF_TXT.usageonoff, true);
	WTF_DisplayAddUsage();
	WTF_DisplayWhoUsage();
	WTF_Print(WTF_HELP_COLOR..WTF_TXT.usage..":|r "..WTF_TOKEN_COLOR..SLASH_COLOR..WTF_HELP_COLOR.." -- "..WTF_TXT.usagecolor, true);
	WTF_Print(WTF_HELP_COLOR..WTF_TXT.usage..":|r "..WTF_TOKEN_COLOR..SLASH_DEBUG..WTF_HELP_COLOR.." -- "..WTF_TXT.usagedebug, true);
end

-- DisplayAddUsage
----------------------
function WTF_DisplayAddUsage()
	WTF_Print(WTF_HELP_COLOR..WTF_TXT.usage..":|r "..WTF_TOKEN_COLOR..SLASH_ADD.." <playername> <note>"..WTF_HELP_COLOR.." -- "..WTF_TXT.usageadd, true);
end

-- DisplayWhoUsage
function WTF_DisplayWhoUsage()
	WTF_Print(WTF_HELP_COLOR..WTF_TXT.usage..":|r "..WTF_TOKEN_COLOR..SLASH_WHO.." <playername>"..WTF_HELP_COLOR.." -- "..WTF_TXT.usagewho, true);
end

-- Display Status
-----------------------
function WTF_DisplayStatus()
	message = WTF_NAME..": ";
	if (WTF_State.enabled) then
		message = message..WTF_NORMAL_COLOR..WTF_TXT.enabled;
	else
		message = message..WTF_ERROR_COLOR..WTF_TXT.disabled;
	end
	
	message = message.." "..WTF_HELP_COLOR..WTF_TXT.colormode..": "
	if (WTF_State.color) then		
		message = message..WTF_NORMAL_COLOR..WTF_TXT.enabled;
	else
		message = message..WTF_ERROR_COLOR..WTF_TXT.disabled;
	end
		
	if (WTF_State.debug) then
		message = message..WTF_NORMAL_COLOR.."  ##DEBUG MODE##";
	end
	DEFAULT_CHAT_FRAME:AddMessage(message);
end
-- Original Author and Manager : Zaultar
-- Update Author : Jaxom of Hellfire
-- Create Date : 11/27/2008 10:17:49 PM
-- Update Date : 24/12/2014 by Jaxom of Hellfire
-- _O1_ OnLoad()
-- _02_ OnEvent()

-- Addon constants
WTF_NAME 	= "Who TF RU"
WTF_VNMBR	= 600000		-- Number code for this version

-- Colors
WTF_HELP_COLOR		= "|cFFFFFF7F"
WTF_ERROR_COLOR	    = "|cFFFF0000"
WTF_UNKNOWN_COLOR	= "|cFF7F7F7F"
WTF_TOKEN_COLOR	    = "|cFFFF0000"
WTF_NORMAL_COLOR     = "|r"

WTF_NOTE_COLOR       = "|cFFFFFF7F"   -- Who TF RU
WTF_FRIEND_COLOR     = "|cFFE5B200"   -- Neutral
WTF_GUILD_COLOR      = "|cFF00FF00"   -- or lighter green "|cFFC0FFC0"

-- Stored Data
if not WTF_State then WTF_State = {} end		-- Data saved between sessions
if not WTF_Notes then WTF_Notes = {} end		-- Names database
if not WTF_FNotes then WTF_FNotes = {} end	-- Friend Notes database
if not WTF_GNotes then WTF_GNotes = {} end	-- Guild Notes database
if not WTF_FData then WTF_FData = {} end		-- Friend Data (level, class zone)
if not WTF_GData then WTF_GData = {} end		-- Friend Data (level, class zone)

-- Slash variables
local SLASH_ON = "on";			-- Enabled Who TF RU? (really?)
local SLASH_OFF = "off";		-- Enabled Who TF RU? (really?)
local SLASH_ADD = "add"			-- Add a player note
local SLASH_WHO = "whois"		-- Whois a user
local SLASH_COLOR = "color"		-- Toggles Color on/off
local SLASH_DEBUG = "debug";	-- Toggles Debug output on/off
local SLASH_STATUS = "status";  -- Displays current settings
local SLASH_FRIENDS = "friends";-- Dump friends notes into array
local SLASH_GUILD = "guild";    -- Dump friends notes into array

local WTF_Global_Name = "";
local WTF_Global_Note = "";


-- _01_ OnLoad() Handler	
------------------------------------------------------------
function WTF_OnLoad(self) 
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("FRIENDLIST_UPDATE");
	self:RegisterEvent("GUILD_ROSTER_UPDATE");
	self:RegisterEvent("VARIABLES_LOADED");
	
	SLASH_CHATNOTES1 = "/chatnotes"
	SLASH_CHATNOTES2 = "/cn"
	SlashCmdList["CHATNOTES"] = WTF_ParseSlash;
	
	SLASH_WHOIS1 = "/whois"
	SlashCmdList["WHOIS"] = WTF_WhoPlayer;

	SLASH_ADD1 = "/add"
	SlashCmdList["ADD"] = WTF_AddCommand;
	
	DEFAULT_CHAT_FRAME:AddMessage(WTF_HELP_COLOR..WTF_NAME..":|r "..WTF_TXT.loaded..WTF_HELP_COLOR..WTF_TXT.loadedtext);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", WTF_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", WTF_ChatFilter)
	
	-- use ChatFilter_System (a copy of ChatFilter) so we can see if we see strings without account names.
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", WTF_ChatFilter_System)

	-- Chat Frame Menu to add/remove
	UnitPopupMenus["CHATNOTES"] = {"CHATNOTES_ADD", "CHATNOTES_REMOVE", "CANCEL"};
	UnitPopupButtons["CHATNOTES"] = { text = WTF_MENU_MAIN, dist = 0, nested = 1};
	UnitPopupButtons["CHATNOTES_ADD"] = { text = WTF_MENU_ADD, dist = 0,};
	UnitPopupButtons["CHATNOTES_REMOVE"] = { text = WTF_MENU_REMOVE, dist = 0 };

	table.insert(UnitPopupMenus["PLAYER"], #UnitPopupMenus["PLAYER"]-1, "CHATNOTES");
	table.insert(UnitPopupMenus["FRIEND"], #UnitPopupMenus["FRIEND"]-1, "CHATNOTES");
	table.insert(UnitPopupMenus["PARTY"], #UnitPopupMenus["PARTY"]-1, "CHATNOTES");

	hooksecurefunc("UnitPopup_OnClick", WTF_UnitPopupOnClick);
	
	-- Static PopUp Dialogs
    
	StaticPopups();
end

function StaticPopups(self)
	-- You have you are removing a player's Who TF RU
   	StaticPopupDialogs["CHATNOTE_POPUP_REMOVE"] = {
		text = "Are you sure you want to REMOVE the Who TF RU for (%s)",
		button1 = TEXT(YES),
		button2 = TEXT(NO),
		OnAccept = function(data)
			data = WTF_Global_Name
		    if (data) then 
				if (WTF_Notes[data]) then
					WTF_Notes[data] = nil
					WTF_Debug("("..data..") Who TF RU REMOVED")
				else
					WTF_Debug("("..data..") Doesn't exist in WTF_Notes")
				end
			end
		end,
		OnHide = function(data)
		end,
		whileDead = 1;
		timeout = 30;
		hideOnEscape = 1
	};
	-- Add or Modify a players existing Who TF RU
   	StaticPopupDialogs["CHATNOTE_POPUP_ADDMODIFY"] = {
		text = "Set Who TF RU for player (%s)",
		button1 = TEXT(YES),
		button2 = TEXT(NO),
		OnShow = function(self)
			if (WTF_Global_Note) then self.editBox:SetText(WTF_Global_Note) end
		end,
        	OnAccept = function(self, data)
			local player = WTF_Global_Name
			local note = nil
			note = self.editBox:GetText()
			-- Set a blank to a nil to erase value
			if (note == "") then note = nil end
			if (note) then
				WTF_Notes[player] = note
			    WTF_Debug("Added Note for ["..player.."] ("..note..")");
			end
--			if (self.editBox:GetText()) then WTF_Debug("Data Name:"..self.editBox:GetText()) end
		end,
		OnHide = function(data)
		    WTF_Debug("OnHide:");
		end,
        	EditBoxOnEnterPressed = function(self)
			local player = WTF_Global_Name
			local note = nil
			note = self:GetText()
			-- Set a blank to a nil to erase value
			if (note == "") then note = nil end
			if (note) then
				WTF_Notes[player] = note
--		    WTF_Debug("Added Note for ["..player.."] ("..note..")");
			end
			WTF_Debug("Enter Pressed")
			self:GetParent():Hide();
        	end,
    		EditBoxOnEscapePressed = function (self)
        		self:GetParent():Hide();
    		end,		
		whileDead = 1,
		timeout = 0,
		exclusive = 1,
		hideOnEscape = 1,
		hasEditBox = 1
	};
end

-- PopUp Menu on chat frame
function WTF_UnitPopupOnClick(self)
	local dropdownFrame = UIDROPDOWNMENU_INIT_MENU;
	local button = self.value;
	local name = dropdownFrame.name;
	
	if button == "CHATNOTES_ADD" then
	    WTF_Debug ("CHATNOTES_ADD Name:"..name);
	    WTF_Global_Name = name
	    if (WTF_Notes[name]) then
			WTF_Global_Note = WTF_Notes[name]
		else
			WTF_Global_Note = ""
		end
	    local dialog = StaticPopup_Show("CHATNOTE_POPUP_ADDMODIFY", name);
		if dialog then dialog.data = name end
	    WTF_Debug ("CHATNOTES_ADD  Name:"..name);
	    ToggleDropDownMenu(1, nil, dropdownFrame, "cursor");
	elseif button == "CHATNOTES_REMOVE" then
--	    WTF_Debug ("CHATNOTES_REMOVE  Name:"..name);
		-- Set the name to pass in, since we can't seem to figure out the parameters
	    WTF_Global_Name = name
	    local dialog = StaticPopup_Show("CHATNOTE_POPUP_REMOVE", name);
		if dialog then dialog.data = name end
--	    WTF_Debug ("CHATNOTES_REMOVE  Name:"..name);
	    ToggleDropDownMenu(1, nil, dropdownFrame, "cursor");
	elseif button == "CANCEL" then
	    ToggleDropDownMenu(1, nil, dropdownFrame, "cursor");
	end

	return;
end


-- Filter Chat input and add our note to the begining of the string.
function WTF_ChatFilter(self,event,msg,author, ...)
	local output = nil
	local note = ""
	if (WTF_Notes[author] ) then
		if (WTF_State.color) then output = WTF_NOTE_COLOR else output = "" end
		note = WTF_Notes[author];
	elseif (WTF_FNotes[author] ) then
		if (WTF_State.color) then output = WTF_FRIEND_COLOR else output = "" end
		note = WTF_FNotes[author];
	elseif (WTF_GNotes[author] ) then
		if (WTF_State.enabled) then
			if (WTF_State.color) then output = WTF_GUILD_COLOR else output = "" end
			note = WTF_GNotes[author];
		end
	end

	-- If we have set anything in output, then we know to output our text
	if (output) then
--		return false, output.."("..note..") "..WTF_NORMAL_COLOR..msg
   	   msg = output.."("..note..") "..WTF_NORMAL_COLOR..tostring(msg)
	   return false, msg,author, ...
	end
end


-- Filter Chat input and add our note to the begining of the string.
function WTF_ChatFilter_System(self,event,msg,...)
	local output = nil
	local note = ""
	local playername = "";
	local playernotes = nil;
	local playerdata = nil;

	-- For system messages fire and set msg to full string, with name inside
	if (string.find(msg, WTF_TXT.sys_goneoffline)) then
	   playername = string.sub(msg, 1, string.find(msg, " ")-1)
	   --WTF_Debug("<"..playername..">");
	   
	   if (WTF_GNotes[playername]) then playernotes = WTF_GNotes[playername]; end
	   if (WTF_FNotes[playername]) then playernotes = WTF_FNotes[playername]; end
	   if (WTF_Notes[playername]) then playernotes = WTF_Notes[playername]; end
	   
	   if (WTF_GData[playername]) then playerdata = WTF_GData[playername]; end
	   if (WTF_FData[playername]) then playerdata = WTF_FData[playername]; end
	   
	   if (playernotes) then
		  output = playername.." ("..playernotes..")";
		  if (playerdata) then
			 output = output.." "..playerdata;
		  end
		  output = output.." "..WTF_TXT.sys_goneoffline;
	   end
   	end

	if (string.find(msg, WTF_TXT.sys_comeonline)) then
		WTF_Debug(">"..msg.."<");
		-- sometimes online has a [<playername>] and sometimes it doesn't (guild).
		if (string.find(msg,"|")) then
			playername = string.sub (msg, string.find(msg, ":", 1, true)+1 )
			playername = string.sub (playername, 1 , string.find(playername, "|", 1, true)-1 )
		else
			playername = string.sub(msg, 2, string.find(msg, "]")-1)
		end
		WTF_Debug("<"..playername..">");

		   
	   if (WTF_GNotes[playername]) then playernotes = WTF_GNotes[playername]; end
	   if (WTF_FNotes[playername]) then playernotes = WTF_FNotes[playername]; end
	   if (WTF_Notes[playername]) then playernotes = WTF_Notes[playername]; end
	   
	   if (WTF_GData[playername]) then playerdata = WTF_GData[playername]; end
	   if (WTF_FData[playername]) then playerdata = WTF_FData[playername]; end
	   
	   if (playernotes) then
		  output = playername.." ("..playernotes..")";
		  if (playerdata) then
			 output = output.." "..playerdata;
		  end
		  output = output.." "..WTF_TXT.sys_comeonline;
	   end
   	end

	-- <name> joins the party. (sys_joinsparty)
	if (string.find(msg, "joins the party")) then
		WTF_Debug(">"..msg.."<");
	end
	-- If we have set anything in output, then we know to output our text
	if (output) then
		return false, output, ...
	end
end


-- _02_ OnEvent() Handler
------------------------------------------------------------
function WTF_OnEvent(self, event, arg1, ...) 
	if (event == "ADDON_LOADED") then
		if (arg1 == "WTF") then
			-- TODO output to screen when setting defaults!
			-- Set State Variables
			if WTF_State.debug == nil then WTF_State.debug = false end
			if WTF_State.color == nil then WTF_State.color = false end
			if WTF_State.enabled == nil then WTF_State.enabled = true end
			-- Display Status
			WTF_DisplayStatus()
			WTF_PanelOptions()
			WTF_PanelUpdate()
		end
	elseif (event == "VARIABLES_LOADED") then
		WTF_Debug(event.."(START)")
		WTF_Debug(event.." (END)")
	elseif (event == "GUILD_ROSTER_UPDATE") then
		WTF_GuildList();
	elseif (event == "FRIENDLIST_UPDATE") then
		WTF_FriendsList(false);
	end
end


function WTF_PanelOptions()
	WTF_OptionsHeader = WTF_Panel:CreateFontString(nil, "ARTWORK")
	WTF_OptionsHeader:SetFontObject(GameFontNormalLarge)
	WTF_OptionsHeader:SetPoint("TOPLEFT", 16, -16)
	WTF_OptionsHeader:SetText("Who TF RU v1.5.2")
	
	WTF_GeneralHeader = WTF_Panel:CreateFontString(nil, "ARTWORK")
	WTF_GeneralHeader:SetFontObject(GameFontWhite)
	WTF_GeneralHeader:SetPoint("TOPLEFT", WTF_OptionsHeader, "BOTTOMLEFT", 0, -6)
	WTF_GeneralHeader:SetText("General Options:")
    
    WTF_GeneralHeader1 = WTF_Panel:CreateFontString(nil, "ARTWORK")
	WTF_GeneralHeader1:SetFontObject(GameFontWhite)
	WTF_GeneralHeader1:SetPoint("TOPLEFT", WTF_OptionsHeader, "BOTTOMLEFT", 0, -20)
	WTF_GeneralHeader1:SetText("Authors: Zaultar of ??? and Jaxom of Hellfire")

	WTF_PanelGuildNotes = CreateFrame("CheckButton", "WTF_PanelGuildNotes", WTF_Panel, "OptionsCheckButtonTemplate")
	WTF_PanelGuildNotes:SetPoint("TOPLEFT", "WTF_GeneralHeader", "BOTTOMLEFT", 0, -15)
	WTF_PanelGuildNotesText:SetText("Automatically display Guild Notes")

	WTF_PanelColor = CreateFrame("CheckButton", "WTF_PanelColor", WTF_Panel, "OptionsCheckButtonTemplate")
	WTF_PanelColor:SetPoint("TOPLEFT", "WTF_PanelGuildNotes", "BOTTOMLEFT", 0, -4)
	WTF_PanelColorText:SetText("Colorize notes based on where they are set")

    
        
end

function WTF_PanelUpdate()
	WTF_PanelGuildNotes:SetChecked(WTF_State.enabled)
	WTF_PanelColor:SetChecked(WTF_State.color)
end

function WTF_PanelOkay()
	WTF_State.enabled = WTF_PanelGuildNotes:GetChecked()
	WTF_State.color = WTF_PanelColor:GetChecked()
end

function WTF_PanelSettingsDefault()
	-- WTF_PanelGuildNotes:SetChecked(WTF_State.enabled)

end


function WTF_Panel_OnLoad(WTF_Panel)
---------
	WTF_Panel.name = "Who TF RU"
	WTF_Panel.okay = function (self) WTF_PanelOkay(); end;
	WTF_Panel.default = function (self) WTF_PanelSettingsDefault(); WTF_PanelUpdate(); end;
	InterfaceOptions_AddCategory(WTF_Panel)

end --function


-- _03_ - OnEvent Functions
------------------------------------------------------------

-- Main routine for adding a Note to a specific player name
------------------------------------------------------------
function WTF_AddPlayerNote (player, note)
	local previousnote = WTF_Notes[player];
	if (previousnote) then
		WTF_Notes[player] = note;
		DEFAULT_CHAT_FRAME:AddMessage(WTF_HELP_COLOR..WTF_TXT.updated..WTF_NORMAL_COLOR..string.format(" %s:%s (it was: %s)",player,note,previousnote));
	else
		WTF_Notes[player] = note;
		DEFAULT_CHAT_FRAME:AddMessage(string.format(WTF_HELP_COLOR..WTF_TXT.added..WTF_NORMAL_COLOR.." %s:%s",player,note));
	end
end

-- _04_ Chat Window Functions

------------------------
-- _05_ Slash Handler --
------------------------

-- Main Slash Command handler
------------------------------------------------------------
function WTF_ParseSlash(msg) 
	local cmd, params = WTF_Extract_NextParameter(msg);
	if (cmd == SLASH_ON) then	
		WTF_State.enabled = true;
		WTF_PanelUpdate();
		WTF_DisplayStatus();
	elseif (cmd == SLASH_OFF) then
		WTF_State.enabled = false;
		WTF_PanelUpdate();
		WTF_DisplayStatus();
	elseif (cmd == SLASH_STATUS) then
		WTF_DisplayStatus();
	elseif (cmd == SLASH_ADD) then
		if (params) then
			local playername, note = WTF_Extract_NextParameter(params);
			WTF_AddPlayerNote(WTF_MixedCase(playername), note);
		else
			WTF_DisplayAddUsage();
		end
	elseif (cmd == SLASH_WHO) then
		if (params) then
			WTF_WhoPlayer(params);
		else
			WTF_DisplayWhoUsage();
		end
	elseif (cmd == SLASH_COLOR) then
	    WTF_State.color = not WTF_State.color
	    WTF_PanelUpdate();
	    WTF_DisplayStatus();
	elseif (cmd == SLASH_FRIENDS) then
		WTF_FriendsList(true);
	elseif (cmd == SLASH_GUILD) then
		WTF_GuildList(true);
	elseif (cmd == SLASH_DEBUG) then
		WTF_State.debug = not WTF_State.debug;
		WTF_DisplayStatus();
	else 
		--WTF_DisplayUsage();
		InterfaceOptionsFrame_OpenToCategory(WTF_Panel)
	end
	
end

-- Generic Add command, parses input to ensure we have a name value pair
------------------------------------------------------------
function WTF_AddCommand (cmd)
	if (cmd) then
		local playername, note = WTF_Extract_NextParameter(cmd);

		-- Normalize the inputed player name
		playername = WTF_MixedCase(playername)
		
		if (note) then
			WTF_AddPlayerNote (playername, note);
		else
			WTF_DisplayAddUsage();
		end
	else
		WTF_DisplayUsage();
	end
end

-- /whois handler for quick query of a username
------------------------------------------------------------
function WTF_WhoPlayer (player)
	local playernote = nil
	local playerdata = ""

	-- Normalize the inputed player name
	player = WTF_MixedCase(player)

	-- Get Player Data from either Friend or Guild
	if (WTF_GData[player]) then
		playerdata = WTF_GData[player]
	end
	if (WTF_FData[player]) then
		playerdata = WTF_FData[player]
	end

	if (WTF_Notes[player]) then
		WTF_Print(WTF_HELP_COLOR.."Whois: ["..player.."]: ("..WTF_Notes[player]..")")
	elseif (WTF_FNotes[player]) then
		WTF_Print(WTF_HELP_COLOR.."Whois: ["..player.."]: ("..WTF_FNotes[player]..")"..playerdata)
	elseif (WTF_GNotes[player]) then
		WTF_Print(WTF_HELP_COLOR.."Whois: ["..player.."]: ("..WTF_GNotes[player]..")"..playerdata)
	end		
end

function WTF_FriendsList(output)
	local numFriends = GetNumFriends();
--	WTF_Debug ("Friends: "..numFriends);
	local numFriendsOnline = 0;
	local name, level, class, zone, connected, status, note
	local friendIndex
	if (numFriends > 0) then
		for friendIndex=1, numFriends do
			name, level, class, zone, connected, status, note = GetFriendInfo(friendIndex);
			if (name) then
				-- If we have class info, then we know we got something.
				if (level > 0) then
					if (not zone) then zone="" end
					WTF_FData[name]=class.." ("..level..") in "..zone
				end 
				if (note) then
					note = strtrim(note);
					if (note) then
						if (output) then
							WTF_Print("["..name.."] ("..note..")");
						end
						WTF_FNotes[name]=note;
					else
						if (output) then
							WTF_Print("["..name.."]");
						end
						WTF_FNotes[name]=nil;
					end
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("Error: Problem retrieving friend information")
			end
			num=friendIndex;
		end
		if (output) then
			WTF_Print("Retrieved data for "..num.." friends")
		end
	else
		WTF_Debug("[WTF] Friend info unavailable. Please open the friend window once per session.")
	end
end

-- Populate the WTF_GNotes database?
----------------------------------
function WTF_GuildList(output)
	local numGuild = GetNumGuildMembers();
	local numGuildOnline = 0;
	local name, level, class, zone, connected, status, note
	local guildIndex
	if (numGuild > 0) then
--		WTF_Debug ("Guild: "..numGuild);
		for guildIndex=1, numGuild do
			name, rank, rankIndex, level, class, zone, note, officernote, connected = GetGuildRosterInfo(guildIndex);
			if (name) then
				-- If we have class info, then we know we got something.
				if (level > 0) then
					if (not zone) then zone="" end
					WTF_GData[name]=class.." ("..level..") in "..zone
				end 
				-- Check it exists, and if so, trim any white space
				if (note) then
					note = strtrim(note);
					if (note) then
						if (output) then
							WTF_Print("["..name.."] ("..note..")");
						end
						if (strlen(note) > 0) then
						   WTF_GNotes[name]=note;
						else
							WTF_GNotes[name]=nil;
						end
					else
						if (output) then
							WTF_Print("["..name.."]");
						end
						WTF_GNotes[name]=nil;
					end
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("Error: Problem retrieving guild information")
			end
			num=guildIndex;
		end
		if (output) then
			WTF_Print("Retrieved data for "..num.." guild members")
		end
	else
		WTF_Debug("[WTF] Guild info unavailable. Please open the guild window once per session.")
	end
end

function WTF_DumpColor()
FIZ_HELP_COLOUR		= "|cFFFFFF7F"
FIZ_ERROR_COLOUR	= "|cFFFF0000"
FIZ_UNKNOWN_COLOUR	= "|cFF7F7F7F"
FIZ_HOSTILE_COLOUR	= "|cFFCC4C38"
FIZ_NEUTRAL_COLOUR	= "|cFFE5B200"
FIZ_FRIENDLY_COLOUR	= "|cFF009919"
FIZ_NEW_REP_COLOUR	= "|cFF7F7FFF"
FIZ_NEW_STANDING_COLOUR	= "|cFF6060C0"
FIZ_BAG_COLOUR		= "|cFFC0FFC0"
FIZ_BAG_BANK_COLOUR	= "|cFFFFFF7F"
FIZ_QUEST_COLOUR	= "|cFFC0FFC0"
FIZ_HIGHLIGHT_COLOUR    = "|cFF00FF00"
FIZ_QUEST_ACTIVE_COLOUR	= "|cFFFF7F7F"
FIZ_LOWLIGHT_COLOUR	= "|cFFFF3F3F"
FIZ_SUPPRESS_COLOUR	= "|cFF7F7F7F"

    WTF_Debug(FIZ_HELP_COLOUR.."FIZ_HELP_COLOUR"..FIZ_ERROR_COLOUR.."FIZ_ERROR_COLOUR"..FIZ_UNKNOWN_COLOUR.."FIZ_UNKNOWN_COLOUR"..FIZ_HOSTILE_COLOUR.."FIZ_HOSTILE_COLOUR"..FIZ_NEUTRAL_COLOUR.."FIZ_NEUTRAL_COLOUR"..FIZ_FRIENDLY_COLOUR.."FIZ_FRIENDLY_COLOUR"..FIZ_NEW_REP_COLOUR.."FIZ_NEW_REP_COLOUR"..FIZ_NEW_STANDING_COLOUR.."FIZ_NEW_STANDING_COLOUR"..FIZ_BAG_COLOUR.."FIZ_BAG_COLOUR"..FIZ_BAG_BANK_COLOUR.."FIZ_BAG_BANK_COLOUR"..FIZ_QUEST_COLOUR.."FIZ_QUEST_COLOUR"..FIZ_HIGHLIGHT_COLOUR.."FIZ_HIGHLIGHT_COLOUR"..FIZ_QUEST_ACTIVE_COLOUR.."FIZ_QUEST_ACTIVE_COLOUR"..FIZ_LOWLIGHT_COLOUR.."FIZ_LOWLIGHT_COLOUR"..FIZ_SUPPRESS_COLOUR.."FIZ_SUPPRESS_COLOUR");
end

-- Handles processing commandline items in single chunks
------------------------------------------------------------
function WTF_Extract_NextParameter(msg)
	local params = msg;
	local command = params;
	local index = strfind(command, " ");
	if ( index ) then
		command = strsub(command, 1, index-1);
		params = strsub(params, index+1);
	else
		params = nil;
	end
	return command, params;
end


-----------------------------------
-- _06_ General Helper Functions --
-----------------------------------

------------------------------------------------------------
function WTF_Print(msg, forceDefault)
	if not (msg) then return end
		DEFAULT_CHAT_FRAME:AddMessage(msg)
end

function WTF_Debug(msg)
	if not (msg) then return end
	if (WTF_State.debug) then
		DEFAULT_CHAT_FRAME:AddMessage(msg)
	end
end

function WTF_SafeConcat2(str1, str2)
	if str1 and str2 then 
		return str1..str2
	elseif str1 then
		return str1
	elseif str2 then
		return str2
	else
		return nil
	end
end

-- Returns the string in proper Mixed Case... First letter capitalized, the rest lower
function WTF_MixedCase(str)
	--return string.upper(string.sub(str,1,1))..string.sub(string.lower(str),2,-1))
	local Mixed = string.upper(str:sub(1,1))..string.sub(str:lower(),2,-1)
	--return string.upper(string.sub(str,1,1))..string.sub(string.lower(str),2,-1))
	return Mixed
end

-----------------------------------
-- _07_ Information
-----------------------------------

------------------------------------------------------------
function WTF_About()
	local ver = GetAddOnMetadata("WTF", "Version");
	local date = GetAddOnMetadata("WTF", "X-Date");
	local author = GetAddOnMetadata("WTF", "Author");
	local web = GetAddOnMetadata("WTF", "X-Website");

	if (author ~= nil) then
		WTF_Print(WTF_NAME.." "..WTF_TXT.by.." "..WTF_HELP_COLOR..author.."|r", true);
	end
	if (ver ~= nil) then
		WTF_Print("  "..WTF_TXT.version..": "..WTF_HELP_COLOR..ver.."|r", true);
	end
	if (date ~= nil) then
		WTF_Print("  "..WTF_TXT.date..": "..WTF_HELP_COLOR..date.."|r", true);
	end
	if (web ~= nil) then
		WTF_Print("  "..WTF_TXT.web..": "..WTF_HELP_COLOR..web.."|r", true);
	end
end


function WTF_DisplayUsage()
	-- WTF_Print(" ", true);
	WTF_Print(WTF_HELP_COLOR..WTF_NAME..":|r "..WTF_TXT.help, true);
	WTF_Print(WTF_HELP_COLOR..WTF_TXT.usage..":|r "..WTF_TOKEN_COLOR..SLASH_ON.."/"..SLASH_OFF..WTF_HELP_COLOR.." -- "..WTF_TXT.usageonoff, true);
	WTF_DisplayAddUsage();
	WTF_DisplayWhoUsage();
	WTF_Print(WTF_HELP_COLOR..WTF_TXT.usage..":|r "..WTF_TOKEN_COLOR..SLASH_COLOR..WTF_HELP_COLOR.." -- "..WTF_TXT.usagecolor, true);
	WTF_Print(WTF_HELP_COLOR..WTF_TXT.usage..":|r "..WTF_TOKEN_COLOR..SLASH_DEBUG..WTF_HELP_COLOR.." -- "..WTF_TXT.usagedebug, true);
end

-- DisplayAddUsage
----------------------
function WTF_DisplayAddUsage()
	WTF_Print(WTF_HELP_COLOR..WTF_TXT.usage..":|r "..WTF_TOKEN_COLOR..SLASH_ADD.." <playername> <note>"..WTF_HELP_COLOR.." -- "..WTF_TXT.usageadd, true);
end

-- DisplayWhoUsage
function WTF_DisplayWhoUsage()
	WTF_Print(WTF_HELP_COLOR..WTF_TXT.usage..":|r "..WTF_TOKEN_COLOR..SLASH_WHO.." <playername>"..WTF_HELP_COLOR.." -- "..WTF_TXT.usagewho, true);
end

-- Display Status
-----------------------
function WTF_DisplayStatus()
	message = WTF_NAME..": ";
	if (WTF_State.enabled) then
		message = message..WTF_NORMAL_COLOR..WTF_TXT.enabled;
	else
		message = message..WTF_ERROR_COLOR..WTF_TXT.disabled;
	end
	
	message = message.." "..WTF_HELP_COLOR..WTF_TXT.colormode..": "
	if (WTF_State.color) then		
		message = message..WTF_NORMAL_COLOR..WTF_TXT.enabled;
	else
		message = message..WTF_ERROR_COLOR..WTF_TXT.disabled;
	end
		
	if (WTF_State.debug) then
		message = message..WTF_NORMAL_COLOR.."  ##DEBUG MODE##";
	end
	DEFAULT_CHAT_FRAME:AddMessage(message);
end
